/**
 * @name ranges-regex
 * @fileoverview Integrate regex operations into Ranges workflow
 * @version 5.1.1
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-regex/}
 */

var rangesRegex=(()=>{var $=Object.create;var y=Object.defineProperty;var F=Object.getOwnPropertyDescriptor;var A=Object.getOwnPropertyNames,d=Object.getOwnPropertySymbols,D=Object.getPrototypeOf,m=Object.prototype.hasOwnProperty,S=Object.prototype.propertyIsEnumerable;var h=(e,n,o)=>n in e?y(e,n,{enumerable:!0,configurable:!0,writable:!0,value:o}):e[n]=o,u=(e,n)=>{for(var o in n||(n={}))m.call(n,o)&&h(e,o,n[o]);if(d)for(var o of d(n))S.call(n,o)&&h(e,o,n[o]);return e};var H=(e,n)=>()=>(n||e((n={exports:{}}).exports,n),n.exports),N=(e,n)=>{for(var o in n)y(e,o,{get:n[o],enumerable:!0})},T=(e,n,o,s)=>{if(n&&typeof n=="object"||typeof n=="function")for(let i of A(n))!m.call(e,i)&&i!==o&&y(e,i,{get:()=>n[i],enumerable:!(s=F(n,i))||s.enumerable});return e};var W=(e,n,o)=>(o=e!=null?$(D(e)):{},T(n||!e||!e.__esModule?y(o,"default",{value:e,enumerable:!0}):o,e)),M=e=>T(y({},"__esModule",{value:!0}),e);var I=H((c,p)=>{var k="[object RegExp]",q=typeof global=="object"&&global&&global.Object===Object&&global,E=typeof c=="object"&&c&&!c.nodeType&&c,w=E&&typeof p=="object"&&p&&!p.nodeType&&p,C=w&&w.exports===E,v=C&&q.process,R=function(){try{return v&&v.binding("util")}catch(e){}}(),j=R&&R.isRegExp;function P(e){return function(n){return e(n)}}var U=Object.prototype,G=U.toString;function V(e){return z(e)&&G.call(e)==k}function z(e){var n=typeof e;return!!e&&(n=="object"||n=="function")}var B=j?P(j):V;p.exports=B});var X={};N(X,{rRegex:()=>Q,version:()=>L});var J={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function f(e,n){if(!Array.isArray(e)||!e.length)return e;let o=u(u({},J),n),s,i;if(o.strictlyTwoElementsInRangeArrays&&!e.every((a,l)=>!Array.isArray(a)||a.length!==2?(s=l,i=a.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${s}th range (${JSON.stringify(e[s],null,4)}) has not two but ${i} elements!`);if(!e.every((a,l)=>!Array.isArray(a)||!Number.isInteger(a[0])||a[0]<0||!Number.isInteger(a[1])||a[1]<0?(s=l,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${s}th range (${JSON.stringify(e[s],null,4)}) does not consist of only natural numbers!`);let t=e.length**2,g=0;return Array.from(e).sort((a,l)=>(o.progressFn&&(g+=1,o.progressFn(Math.floor(g*100/t))),a[0]===l[0]?a[1]<l[1]?-1:a[1]>l[1]?1:0:a[0]<l[0]?-1:1))}var b={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function x(e,n){function o(r){return r&&typeof r=="object"&&!Array.isArray(r)}if(!Array.isArray(e)||!e.length)return null;let s;if(n)if(o(n)){if(s=u(u({},b),n),s.progressFn&&o(s.progressFn)&&!Object.keys(s.progressFn).length)s.progressFn=null;else if(s.progressFn&&typeof s.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof s.progressFn}", equal to ${JSON.stringify(s.progressFn,null,4)}`);if(![1,2,"1","2"].includes(s.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof s.mergeType}", equal to ${JSON.stringify(s.mergeType,null,4)}`);if(typeof s.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof s.joinRangesThatTouchEdges}", equal to ${JSON.stringify(s.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(n,null,4)} (type ${typeof n})`);else s=u({},b);let i=e.filter(r=>Array.isArray(r)).map(r=>[...r]).filter(r=>r[2]!==void 0||r[0]!==r[1]),t,g,a;s.progressFn?t=f(i,{progressFn:r=>{a=Math.floor(r/5),a!==g&&(g=a,s.progressFn(a))}}):t=f(i);let l=t.length-1;for(let r=l;r>0;r--)s.progressFn&&(a=Math.floor((1-r/l)*78)+21,a!==g&&a>g&&(g=a,s.progressFn(a))),(t[r][0]<=t[r-1][0]||!s.joinRangesThatTouchEdges&&t[r][0]<t[r-1][1]||s.joinRangesThatTouchEdges&&t[r][0]<=t[r-1][1])&&(t[r-1][0]=Math.min(t[r][0],t[r-1][0]),t[r-1][1]=Math.max(t[r][1],t[r-1][1]),t[r][2]!==void 0&&(t[r-1][0]>=t[r][0]||t[r-1][1]<=t[r][1])&&t[r-1][2]!==null&&(t[r][2]===null&&t[r-1][2]!==null?t[r-1][2]=null:t[r-1][2]!=null?+s.mergeType==2&&t[r-1][0]===t[r][0]?t[r-1][2]=t[r][2]:t[r-1][2]+=t[r][2]:t[r-1][2]=t[r][2]),t.splice(r,1),r=t.length);return t.length?t:null}var _=W(I(),1);var O="5.1.1";var L=O;function Q(e,n,o){if(e===void 0)throw new TypeError("ranges-regex: [THROW_ID_01] The first input's argument must be a regex object! Currently it is missing!");if(!(0,_.default)(e))throw new TypeError(`ranges-regex: [THROW_ID_02] The first input's argument must be a regex object! Currently its type is: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(typeof n!="string")throw new TypeError(`ranges-regex: [THROW_ID_03] The second input's argument must be a string! Currently its type is: ${typeof n}, equal to: ${JSON.stringify(n,null,4)}`);if(o&&typeof o!="string")throw new TypeError(`ranges-regex: [THROW_ID_04] The third input's argument must be a string or null! Currently its type is: ${typeof o}, equal to: ${JSON.stringify(o,null,4)}`);if(!n.length)return null;let s,i=[];if(o===null||typeof o=="string"&&o.length)for(;(s=e.exec(n))!==null;)i.push([e.lastIndex-s[0].length,e.lastIndex,o]);else for(;(s=e.exec(n))!==null;)i.push([e.lastIndex-s[0].length,e.lastIndex]);return i.length?x(i):null}return M(X);})();
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 8.1.1
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 5.0.12
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
